# class Prism::ClassVariableOrWriteNode

Represents the use of the ‘||=` operator for assignment to a class variable.

    @@target ||= value
    ^^^^^^^^^^^^^^^^^^

### Attributes

name [R]

attr_reader name: `Symbol`

value [R]

attr_reader value: Prism::node

### Public Class Methods

new (source, node_id, location, flags, name, name_loc, operator_loc, value)
Source

    # File lib/prism/node.rb, line 4216
    def initialize(source, node_id, location, flags, name, name_loc, operator_loc, value)
      @source = source
      @node_id = node_id
      @location = location
      @flags = flags
      @name = name
      @name_loc = name_loc
      @operator_loc = operator_loc
      @value = value
    end

Initialize a new `ClassVariableOrWriteNode` node.

type ()
Source

    # File lib/prism/node.rb, line 4308
    def self.type
      :class_variable_or_write_node
    end

Return a symbol representation of this node type. See ‘Node::type`.

### Public Instance Methods

=== (other)
Source

    # File lib/prism/node.rb, line 4314
    def ===(other)
      other.is_a?(ClassVariableOrWriteNode) &&
        (name === other.name) &&
        (name_loc.nil? == other.name_loc.nil?) &&
        (operator_loc.nil? == other.operator_loc.nil?) &&
        (value === other.value)
    end

Implements case-equality for the node. This is effectively == but without comparing the value of locations. Locations are checked only for presence.

accept (visitor)
Source

    # File lib/prism/node.rb, line 4228
    def accept(visitor)
      visitor.visit_class_variable_or_write_node(self)
    end

def accept: (`Visitor` visitor) -> void

child_nodes ()
Source

    # File lib/prism/node.rb, line 4233
    def child_nodes
      [value]
    end

def `child_nodes`: () -> Array[nil | Node]

Also aliased as: deconstruct
comment_targets ()
Source

    # File lib/prism/node.rb, line 4243
    def comment_targets
      [name_loc, operator_loc, value] #: Array[Prism::node | Location]
    end

def `comment_targets`: () -> Array[Node | Location]

compact_child_nodes ()
Source

    # File lib/prism/node.rb, line 4238
    def compact_child_nodes
      [value]
    end

def `compact_child_nodes`: () -> Array

copy (node_id: self.node_id, location: self.location, flags: self.flags, name: self.name, name_loc: self.name_loc, operator_loc: self.operator_loc, value: self.value)
Source

    # File lib/prism/node.rb, line 4248
    def copy(node_id: self.node_id, location: self.location, flags: self.flags, name: self.name, name_loc: self.name_loc, operator_loc: self.operator_loc, value: self.value)
      ClassVariableOrWriteNode.new(source, node_id, location, flags, name, name_loc, operator_loc, value)
    end

def copy: (?node_id: `Integer`, ?location: `Location`, ?flags: `Integer`, ?name: `Symbol`, ?name_loc: `Location`, ?operator_loc: `Location`, ?value: Prism::node) -> `ClassVariableOrWriteNode`

deconstruct ()

def deconstruct: () -> Array[nil | Node]

Alias for: child_nodes
deconstruct_keys (keys)
Source

    # File lib/prism/node.rb, line 4256
    def deconstruct_keys(keys)
      { node_id: node_id, location: location, name: name, name_loc: name_loc, operator_loc: operator_loc, value: value }
    end

def `deconstruct_keys`: (Array keys) -> { node_id: `Integer`, location: `Location`, name: `Symbol`, `name_loc`: `Location`, `operator_loc`: `Location`, value: Prism::node }

inspect ()
Source

    # File lib/prism/node.rb, line 4298
    def inspect
      InspectVisitor.compose(self)
    end

def inspect -> `String`

name_loc ()
Source

    # File lib/prism/node.rb, line 4264
    def name_loc
      location = @name_loc
      return location if location.is_a?(Location)
      @name_loc = Location.new(source, location >> 32, location & 0xFFFFFFFF)
    end

attr_reader `name_loc`: `Location`

operator ()
Source

    # File lib/prism/node.rb, line 4293
    def operator
      operator_loc.slice
    end

def operator: () -> `String`

operator_loc ()
Source

    # File lib/prism/node.rb, line 4277
    def operator_loc
      location = @operator_loc
      return location if location.is_a?(Location)
      @operator_loc = Location.new(source, location >> 32, location & 0xFFFFFFFF)
    end

attr_reader `operator_loc`: `Location`

save_name_loc (repository)
Source

    # File lib/prism/node.rb, line 4272
    def save_name_loc(repository)
      repository.enter(node_id, :name_loc)
    end

Save the `name_loc` location using the given saved source so that it can be retrieved later.

save_operator_loc (repository)
Source

    # File lib/prism/node.rb, line 4285
    def save_operator_loc(repository)
      repository.enter(node_id, :operator_loc)
    end

Save the `operator_loc` location using the given saved source so that it can be retrieved later.

type ()
Source

    # File lib/prism/node.rb, line 4303
    def type
      :class_variable_or_write_node
    end

Return a symbol representation of this node type. See ‘Node#type`.